Records: trait
  includes 
    NumericConversions, Null(Int), Set(OpRec), 
    Total(OpRec, .amount, totalAmount),
    Total(OpRec1, .amount, totalAmount)
  OpRec tuple of amount: Int, location: I, seqno: Pos, reported: Bool
  OpRec1 tuple of amount: Int, location: I, seqno: Pos
  BalRec tuple of location: I, value: Null[Int]
  BalRec1 tuple of value: Null[Int]
  introduces
    proj: OpRec -> OpRec1
    proj: BalRec -> BalRec1
  asserts with or: OpRec, br: BalRec, sor: Set[OpRec], 
               or1: OpRec1, sor1: Set[OpRec1]
    proj(or) = [or.amount, or.location, or.seqno];
    proj(br) = [br.value];
  implies with b: Bool, x: OpRec
    set_reported(x, b).amount = x.amount;
    set_reported(x, b).location = x.location;
    set_reported(x, b).seqno = x.seqno;
    set_reported(x, b).reported = b
