SimulationCEnvBEnv: trait
  includes InvariantBEnv, InvariantCEnv, Traces(CEnv, CEnv, id), 
           Traces(BEnv, CEnv, map), CEnvBEnvLemmas
  introduces 
    F:   States[CEnv], States[BEnv] -> Bool
    inv: States[CEnv]               -> Bool
  asserts with i: I, n: Int, s: States[CEnv], u: States[BEnv], 
               a: Actions[CEnv], x: OpRec, x: BalRec
    id(a) = a;
    map(OK(i)) = OK(i);
    map(requestBalance(i)) = requestBalance(i);
    map(requestDeposit(n, i)) = requestDeposit(n, i);
    map(requestWithdrawal(n, i)) = requestWithdrawal(n, i);
    map(reportBalance(n, i)) = reportBalance(n, i);
    F(s, u) <=> 
         u.active = s.active
      /\ \A x: OpRec (x \in u.ops
                        <=> (   proj(x) \in ((s.C)[x:OpRec.location]).ops 
                             /\ (x.reported <=> 
                                 x.seqno \in ((s.C)[x:OpRec.location]).reports)))
      /\ \A x: BalRec (x \in u.bals <=> [x.value] \in ((s.C)[x:BalRec.location]).bals)
      /\ \A i: I (u.lastSeqno[i] = ((s.C)[i]).lastSeqno)
      /\ \A i: I \A x: OpRec (x \in u.mustInclude[i] 
                                <=> proj(x) \in s.mustInclude[i] /\ x.reported)
  implies SimulationMap(CEnv, BEnv, map, F)
