IOAutomaton(A): trait
  introduces
    start      : States[A]                         -> Bool
    enabled    : States[A], Actions[A]             -> Bool
    effect     : States[A], Actions[A], States[A]  -> Bool
    isStep     : States[A], Actions[A], States[A]  -> Bool
    isExternal : Actions[A]                        -> Bool
    isInternal : Actions[A]                        -> Bool
    isInput    : Actions[A]                        -> Bool
    isOutput   : Actions[A]                        -> Bool
  asserts with a: Actions[A], s, s': States[A]
    isStep(s, a, s') <=> enabled(s, a) /\ effect(s, a, s');
    isExternal(a) <=> isInput(a) \/ isOutput(a);
    ~(isInput(a) /\ isOutput(a));
    isInternal(a) <=> ~isExternal(a);
    isInput(a) => enabled(s, a);
