MarkedMessages: trait
  Mmsg tuple of msg: Msg, mark: Bool
  includes Sequence(Mmsg), SequenceMap(Mmsg, Mmsg, mark, mark)
  introduces
    addMark      : Msg                  -> Mmsg
    subseqMarked : Seq[Mmsg], Seq[Mmsg] -> Bool
  asserts with m: Msg, mm, mm1, mm2: Mmsg, mms, mms1, mms2: Seq[Mmsg]
    addMark(m) = [m, true];
    mark(mm) = set_mark(mm, true);
    subseqMarked(empty, mms ^ mm) <=> subseqMarked(empty, mms) /\ mm.mark;
    subseqMarked(mms, empty) <=> isEmpty(mms);
    subseqMarked(mms1 ^ mm1, mms2 ^ mm2) <=> 
      (subseqMarked(mms1 ^ mm1, mms2) /\ mm2.mark) \/ 
      (subseqMarked(mms1, mms2) /\ mm1 = mm2)
  implies \forall m: Msg, mm, mm1, mm2: Mmsg, mms, mms1, mms2, mms3: Seq[Mmsg]
    subseqMarked(empty, mm ^ mms) <=>  subseqMarked(empty, mms) /\ mm.mark;
    subseqMarked(mm1 ^ mms1, mm2 ^ mms2) <=> 
      (subseqMarked(mm1 ^ mms1, mms2) /\ mm2.mark) \/ 
      (subseqMarked(mms1, mms2) /\ mm1 = mm2);
    subseqMarked(mms, mms);
    (subseqMarked(mms1, mms2) /\ subseqMarked(mms2, mms3))
      => subseqMarked(mms1, mms3);
    (~isEmpty(mms2) /\ subseqMarked(mms1, tl(mms2)))
      => subseqMarked(hd(mms2) ^ mms1, mms2);
    subseqMarked(mms, mms ^ [m, true]);
    subseqMarked(mms, [m, true] ^ mms);
    subseqMarked(mms1, mms2 ^ [m, false]) <=> 
      ~isEmpty(mms1) /\ last(mms1) = [m, false] /\ subseqMarked(init(mms1), mms2);
    subseqMarked(mms1, [m, false] ^ mms2) <=> 
      ~isEmpty(mms1) /\ hd(mms1) = [m, false] /\ subseqMarked(tl(mms1), mms2)
