PetersonDefs: trait
  PCType enumeration of 
    waiting0, trying0, trying1, trying2, critical0, critical1
  introduces
    trying, setFlag, setTurn, checkFlag, checkTurn, critical, release:
       ProcType -> PAction
    enabled: PAction -> Bool
    pc: -> Array[ProcType, PCType]
    __[__]: Array[ProcType, PCType], ProcType -> PCType
  asserts with p: ProcType
    enabled(trying(p)) <=> pc[p] = waiting0;
    enabled(setFlag(p)) <=> pc[p] = trying0;
    enabled(setTurn(p)) <=> pc[p] = trying1;
    enabled(checkTurn(p)) <=> pc[p] = trying2;
    enabled(checkFlag(p)) <=> pc[p] = trying2;
    enabled(critical(p)) <=> pc[p] = critical0;
    enabled(release(p)) <=> pc[p] = critical1