Boolean: trait
  % This trait is given for documentation only.
  % It is implicit in LSL.
  introduces
    true, false:                                -> Bool
    ~__:                             Bool       -> Bool
    __/\__, __\/__, __=>__, __<=>__: Bool, Bool -> Bool
  asserts with b: Bool
    sort Bool generated freely by true, false;
    ~true = false;
    ~false = true;
    (true /\ b) = b;
    (false /\ b) = false;
    (true \/ b) = true;
    (false \/ b) = b;
    (true => b) = b;
    (false => b) = true;
    (true <=> b) = b;
    (false <=> b) = ~b
  implies with b1, b2, b3: Bool
    traits AC(Bool, /\), AC(Bool, \/), AC(Bool, <=>),
           Distributive(Bool, \/, /\), Distributive(Bool, /\, \/),
           Involutive(Bool, ~__), Transitive(Bool, =>);
    ~(b1 /\ b2) <=> ~b1 \/ ~b2;
    ~(b1 \/ b2) <=> ~b1 /\ ~b2;
    b1 \/ (b1 /\ b2) <=> b1;
    b1 /\ (b1 \/ b2) <=> b1;
    b2 \/ ~b2;
    b1 = b2 \/ b1 = b3 \/ b2 = b3;
    b1 => b2 <=> ~b1 \/ b2
