ChoiceBag(E): trait
  % A bag with a weakly-specified choose operator.
  includes Bag
  introduces
    choose:  Bag[E] -> E
    rest:    Bag[E] -> Bag[E]
    isEmpty: Bag[E] -> Bool
  asserts with e, e1: E, b: Bag[E]
    b ~= {} => choose(b) \in b;
    b ~= {} => rest(b) = delete(choose(b), b);
    isEmpty(b) <=> b = {}
  implies with b: Bag[E], e: E
    traits Container(E, Bag, {}, insert, choose for head, rest for tail);
    sort Bag[E] partitioned by choose, rest, isEmpty;
    b ~= {} => b = insert(choose(b), rest(b))
