ComposeMaps(D, T, R): trait
  % If m1 maps D to T and m2 maps T to R, then m1 \circ m2 maps D to R.
  assumes Mapping(T, R), Mapping(D, T)
  includes Mapping(D, R)
  introduces __\circ__: Map[D, T], Map[T, R] -> Map[D, R]
  asserts with m1: Map[D, T], m2: Map[T, R], d: D
    (m1 \circ m2)[d] = m2[m1[d]];
    defined(m1 \circ m2, d) <=> defined(m1, d) /\ defined(m2, m1[d])
