% Special Sequence that runtime code uses for I/O.
% lock() and unlock() should always be called in pairs (with lock() before unlock).
% Their only use so far is to emit a Java synchronized block.

LockableSequence(E): trait
  includes Sequence(LSeq[E] for Seq[E])
  introduces
    lock, unlock:   LSeq[E] -> LSeq[E]
