MChoiceSet(E): trait
  % A set with a choose operator specified to be random
  includes Multiset(E)
  introduces
    chooseRandom:  Mset[E] -> E
    rest:    Mset[E] -> Mset[E]
    isEmpty: Mset[E] -> Bool
  asserts with e, e1: E, s: Mset[E]
    s ~= {} => chooseRandom(s) \in s;
    s ~= {} => rest(s) = delete(chooseRandom(s), s);
    isEmpty(s) <=> s = {}
  implies with e: E, s: Mset[E]
    sort Mset[E] partitioned by chooseRandom, rest, isEmpty;
    s ~= {} => s = insert(chooseRandom(s), rest(s))
