PartialOrder(T, <=): trait
  introduces __<=__: T, T -> Bool
  asserts with x, y, z: T    
    x <= x;
    x <= y /\ y <= z => x <= z;
    x <= y /\ y <= x <=> x = y
  implies 
    traits Antisymmetric(T, <=), PreOrder(T, <=), 
           Reflexive(T, <=), Transitive(T, <=);
    sort T partitioned by <=
