Semilattice(T): trait
  assumes PartialOrder(T, <=)
  includes GreatestLowerBound(T, <=, \glb)
  introduces
    \bot:          -> T
    __\lub__: T, T -> T
  asserts with x, y, z: T
    \bot <= x;
    x \lub y = y \lub x;
    x \glb y = y \glb x;
    x <= (x \lub y);
    x <= z /\ y <= z => (x \lub y) <= z
  implies traits AbelianMonoid(T, \lub, \bot), AbelianSemigroup(T, \glb)
