Sequence(E): trait
  % Lists indexed by integers.
  includes List(Seq for List), 
           Count(E, Seq, {}, -|, count), 
           Size(E, Seq, {}, -|, len)
  introduces
    __\in__:    E, Seq[E]   -> Bool
    __\notin__: E, Seq[E]   -> Bool
    __[__]:     Seq[E], Int -> E
    isEmpty:    Seq[E]      -> Bool
  asserts with e, e1, e2: E, s, s1, s2: Seq[E], n: Int
    e \in s <=> count(e, s) > 0;
    e \notin s <=> count(e, s) = 0;
    (e -| s)[1] = e;
    (e -| s)[n + 1] = s[n];
    isEmpty(s) <=> s = {}
  implies with e: E, s, s1, s2: Seq[E], n: Int
    traits Stack(E, Seq for Stack, {} for empty, head for top, tail for pop, 
                 -| for push, len for size),
           Queue(E, Seq for Queue, {} for empty, -| for append, 
                 last for head, init for tail),
           IndexOp(Seq for C, {} for empty, -| for insert);
    sort Seq[E] partitioned by len, __[__];
    sort Seq[E] partitioned by len, head, tail;
    sort Seq[E] partitioned by len, last, init;
    converts count, len, {__}, |-, ||, \in, \notin, head, last, tail, init, 
             __[__], isEmpty, len
      exempting head({}), last({}), tail({}), init({}), ({})[-abs(n)]
