SimulationMap(A1, A2, F): trait
  assumes IOAutomaton(A1), IOAutomaton(A2)
  introduces F: States[A1], States[A2] -> Bool
  asserts with s, s': States[A1], u: States[A2], a: Actions[A1], 
               \alpha: StepSeq[A2]
      start(s) /\ inv(s) => \E u (start(u) /\ F(s, u));
      F(s, u) /\ inv(s) /\ inv(s') /\ isStep(s, a, s') =>
        \E \alpha (   execFrag(\alpha) 
                   /\ first(\alpha) = u
                   /\ F(s', last(\alpha))
                   /\ trace(\alpha) = trace(a))
