SimulationBEnvAEnv: trait
  includes AutomatonAEnv, AutomatonBEnv, Traces(BEnv, BEnv, id), 
           Traces(AEnv, BEnv, map)
  introduces 
    F:   States[BEnv], States[AEnv] -> Bool
    inv: States[BEnv]               -> Bool
  asserts with i: I, n: Int, s: States[BEnv], u: States[AEnv], a: Actions[BEnv]
    id(a) = a;
    map(OK(i)) = OK(i);
    map(requestBalance(i)) = requestBalance(i);
    map(requestDeposit(n, i)) = requestDeposit(n, i);
    map(requestWithdrawal(n, i)) = requestWithdrawal(n, i);
    map(reportBalance(n, i)) = reportBalance(n, i);
    F(s, u) <=>    s.active = u.active
                /\ s.ops = u.ops
                /\ s.bals = u.bals
                /\ s.lastSeqno = u.lastSeqno
                /\ s.chosenOps = u.chosenOps
  implies SimulationMap(BEnv, AEnv, map, F)
  %% This isn't the right implication, because SimulationMap is defined with
  %% respect to an invariant.  The .lp file contains the proper proof
  %% obligation, without an invariant.