SimulationMap (A1, A2, map, F): trait
  assumes Traces(A1, A1, id), Traces(A2, A1, map)
  introduces F: States[A1], States[A2] -> Bool
  asserts with s, s': States[A1], u: States[A2], a: Actions[A1], 
               alpha: StepSeq[A2]
      id(a) = a;
      start(s) => \E u (start(u) /\ F(s, u));
      F(s, u) /\ isStep(s, a, s') =>
        \E alpha (   execFrag(alpha) 
                  /\ first(alpha) = u
                  /\ F(s', last(alpha))
                  /\ trace(alpha) = trace(a))
