ChoiceSet(E): trait
  % A set with a choose operator specified to be random
  includes Set(E)
  introduces
    chooseRandom:  Set[E] -> E
    rest:    Set[E] -> Set[E]
    isEmpty: Set[E] -> Bool
%  asserts with e, e1: E, s: Set[E]
%    s ~= {} => chooseRandom(s) \in s;
%    s ~= {} => rest(s) = delete(chooseRandom(s), s);
%    isEmpty(s) <=> s = {}
%  asserts with e: E, s: Set[E]
%    s ~= {} => s = insert(chooseRandom(s), rest(s))
