Traces(A, labeling): trait
includes Automaton(A) 
includes Relabeling(labeling, Actions[A], Actions)

introduces
  first, last: States[A], ActionSeq[A] -> States[A]
  execFrag: States[A], ActionSeq[A] -> Bool
  {} : -> ActionSeq[A]
  {} : -> Traces
  __*__: Actions[A], ActionSeq[A] -> ActionSeq[A]
  __*__: Actions, Traces -> Traces
  trace: ActionSeq[A] -> Traces
  trace: Actions[A] -> Traces

asserts sort ActionSeq[A] generated freely by {}, *


with s: States[A], pi: Actions[A], alpha: ActionSeq[A]

execFrag(s, {});
execFrag(s, pi * alpha) <=> 
  enabled(s, pi) /\ execFrag(effect(s, pi), alpha);
first(s, alpha) = s;
last(s, {}) = s;
last(s, pi * alpha) = last(effect(s, pi), alpha);
trace({}) = {};
trace(pi * alpha) = (if external(pi) then labeling(pi) * trace(alpha) else trace(alpha));
trace(pi) = trace(pi * {});

