ArithOps(N): trait
  % Defines the operators div and mod relative to + and *
  % for positive denominators.
  assumes TotallyOrdered(N)
  includes Multiplication
  introduces div, mod: N, N -> N
  asserts with x, y: N
    y > 0 =>    0 <= mod(x, y)
             /\ mod(x, y) < y
             /\ mod(x, y) + (div(x, y) * y) = x
