Array2(I1, I2, E): trait
  % Basic two-dimensional array operators.
  introduces
    __[__,__]: Array[I1, I2, E], I1, I2    -> E
    assign:    Array[I1, I2, E], I1, I2, E -> Array[I1, I2, E]
    const:     E                           -> Array[I1, I2, E]
  asserts with a, a1, a2: Array[I1, I2, E], 
               i1, j1: I1, i2, j2: I2, e: E
    assign(a, i1, i2, e)[j1, j2] =
      (if i1 = j1 /\ i2 = j2 then e else a[j1, j2]);
    const(e)[i1, i2] = e;
    \A i1 \A i2 (a1[i1, i2] = a2[i1, i2]) => a1 = a2
