ArraySlice2(I1, I2, E): trait
  % Two-dimensional arrays treated as vectors of vectors.
  includes 
    Array1(I2, E),
    Array1(I1, Array[I2, E], Array[I1, I2, E] for Array[I, E])
  introduces
    __[__,__]: Array[I1, I2, E], I1, I2    -> E
    assign:    Array[I1, I2, E], I1, I2, E -> Array[I1, I2, E]
    const:     E                           -> Array[I1, I2, E]
  asserts with a: Array[I1, I2, E], i1: I1, i2: I2, e: E
    a[i1, i2] = (a[i1])[i2];
    assign(a, i1, i2, e) = assign(a, i1, assign(a[i1], i2, e));
    const(e)[i1, i2] = e
  implies traits Array2(I1, I2, E)
