Bag(E): trait
  % Common bag operators
  includes
    BagBasics,
    DerivedOrders(Bag[E], \subset, \subseteq, \supset, \supseteq),
    Size(E, Bag)
  introduces
    delete:                E, Bag[E]      -> Bag[E]
    {__}:                  E              -> Bag[E]
    __\in__, __\notin__:   E, Bag[E]      -> Bool
    __\U__, __\I__, __-__: Bag[E], Bag[E] -> Bag[E]
  asserts with e, e1, e2: E, b, b1, b2: Bag[E]
    count(e1, delete(e2, b)) =
      (if e1 = e2 then max(0, count(e1, b) - 1) else count(e1, b));
    {e} = insert(e, {});
    e \in b <=> count(e, b) > 0;
    e \notin b <=> count(e, b) = 0;
    count(e, b1 \U b2) = count(e, b1) + count(e, b2);
    count(e, b1 \I b2) = min(count(e, b1), count(e, b2));
    count(e, b1 - b2) = max(0, count(e, b1) - count(e, b2));
    b1 \subseteq b2 <=> b1 - b2 = {}
  implies with e, e1, e2: E, b, b1, b2: Bag[E]
    traits AbelianMonoid(Bag[E], \U, {}),
           JoinOp(E, Bag, \U, {} for empty),
           MemberOps(E, Bag, {} for empty),
           PartiallyOrdered(Bag[E], \subset, \subseteq, \supset, \supseteq);
    insert(e, b) ~= {};
    count(e, b) >= 0;
    count(e, b) <= size(b);
    b1 \subseteq b2 => count(e, b1) <= count(e, b2);
    converts count, \in, \notin, {__}, \U, \I, -:Bag[E],Bag[E]->Bag[E],
      delete, size, \subseteq, \supseteq, \subset, \supset
