ElementTest(pass, E, C, T): trait
  % A filter collects elements accepted by pass.
  assumes InsertGenerated(E, C, empty, insert)
  introduces 
    pass:     E, T    -> Bool
    filter:   C[E], T -> C[E]
    allPass:  C[E], T -> Bool
    somePass: C[E], T -> Bool
  asserts with c: C[E], e: E, t: T
    filter(empty, t) = empty;
    filter(insert(e, c), t) =
       (if pass(e, t) then insert(e, filter(c, t)) else filter(c, t));
    allPass(empty, t);
    allPass(insert(e, c), t) <=> pass(e, t) /\ allPass(c, t);
    somePass(c, t) <=> filter(c, t) ~= empty
  implies converts filter, somePass, allPass
