Exponentiation(T, **, N, 0, succ): trait
  % Repeatedly applies an infix * operator.
  assumes
    ZeroAndSuccessor(N, 0, succ),
    Monoid(T, *, 1)
  introduces __**__: T, N -> T
  asserts with x: T, y: N
    x**0 = 1;
    x**succ(y) = x * (x**y)
  implies with x: T
    x**succ(0) = x
