LexicographicOrder(E, C): trait
  % "Dictionary" order on C[E].
  assumes
    Container,
    StrictTotalOrder(E, <)
  introduces __<__: C[E], C [E]-> Bool
  asserts with c1, c2: C[E]
    c1 < c2 <=>
        c2 ~= empty
          /\ (c1 = empty
              \/ (if head(c1) = head(c2)
                  then tail(c1) < tail(c2)
                  else head(c1) < head(c2)))
  implies 
    traits TotalOrder(C[E], <);
    converts <:C[E],C[E]->Bool
