PairwiseExtension(\circ, \odot, E, C): trait
  % Induces a binary relation on C[E] from a binary relation on E.
  assumes Container(E, C)
  introduces
    __\circ__: E, E       -> E
    __\odot__: C[E], C[E] -> C[E]
  asserts with e1, e2: E, c1, c2: C[E]
    empty \odot empty = empty;
    c1 ~= empty /\ c2 ~= empty =>
      c1 \odot c2 = insert(head(c1) \circ head(c2), tail(c1) \odot tail(c2));
  implies with e: E, c: C[E]
    converts \odot 
      exempting empty \odot insert(e, c), insert(e, c) \odot empty
