Queue(E): trait
  % Common FIFO operators.
  includes Count(E, Queue, empty, append, count),
           Size(E, Queue, empty, append, len)
  introduces 
    empty:               -> Queue[E]
    append:  E, Queue[E] -> Queue[E]
    __\in__: E, Queue[E] -> Bool
    head:    Queue[E]    -> E
    tail:    Queue[E]    -> Queue[E]
    isEmpty: Queue[E]    -> Bool
  asserts with q: Queue[E], e, e1: E
    sort Queue[E] generated freely by empty, append;
    e \in q <=> count(e, q) > 0;
    head(append(e, q)) =
      (if q = empty then e else head(q));
    tail(append(e, q)) =
      (if q = empty then empty else append(e, tail(q)));
    isEmpty(q) <=> q = empty
  implies with q: Queue[E]
    traits Container(E, Queue, empty, append);
    sort Queue[E] partitioned by head, tail, isEmpty;
    converts count, \in, head, tail, len, isEmpty
      exempting head(empty), tail(empty)
