RelationBasics(E): trait
  % e1\<r\>e2 means e1 is related to e2 by r.
  introduces 
    __\<__\>__:  E, Rel[E], E   -> Bool
    \bot, \top, I:              -> Rel[E]
    [__,__]    : E, E           -> Rel[E]
    -__, __\inv: Rel[E]         -> Rel[E]
    __\U__:      Rel[E], Rel[E] -> Rel[E]
  asserts with e, e1, e2, e3, e4: E, r, r1, r2: Rel[E]
    sort Rel[E] partitioned by __\<__\>__;
    ~(e1\<\bot\>e2);
    e1\<\top\>e2;
    e1\<I\>e2 <=> e1 = e2;
    e1\<[e2, e3]\>e4 <=> e1 = e2 /\ e3 = e4;
    e1\<-r\>e2 <=> ~(e1\<r\>e2);
    e1\<r\inv\>e2 <=> e2\<r\>e1;
    e1\<r1 \U r2\>e2 <=> e1\<r1\>e2 \/ e1\<r2\>e2
  implies
    traits AbelianMonoid(Rel[E], \U, \bot),
           Involutive(Rel[E], __\inv),
           Involutive(Rel[E], -__);
    -\bot = \top;
    -\top = \bot;
    \bot\inv = \bot;
    \top\inv = \top;
    converts \U, -, \inv
