IntCycleLemmas: trait
  assumes IntCycle
  asserts with i, j: I
    first < i <=> i ~= first;
    i < succ(j) <=> j ~= last /\ i <= j;
    succ(i) < j <=> (if i = last then j ~= 0 else i < j /\ succ(i) ~= j);
    succ(i) < succ(j) <=> j ~= last /\ (i = last \/ i < j);
    i ~= 0 => (j <= pred(i) <=> j < i);
    pred(i) <= j /\ j < i => j = pred(i);
    i < j => pred(j - i) = pred(j) - i;
    i < j => pred(j - i) = j - succ(i);
    j ~= 0 /\ i < (n - pred(j)) => i <= (last - j)
