Automaton(A): trait
  introduces
    start      : States[A]                         -> Bool
    enabled    : States[A], Actions[A]             -> Bool
    effect     : States[A], Actions[A] -> States[A]
    step     : States[A], Actions[A], States[A]  -> Bool
    external : Actions[A]                        -> Bool
    internal : Actions[A]                        -> Bool
    input    : Actions[A]                        -> Bool
    output   : Actions[A]                        -> Bool
  asserts with a: Actions[A], s, s': States[A]
    step(s, a, s') <=> enabled(s, a) /\ (effect(s, a) = s');
    external(a) <=> input(a) \/ output(a);
    ~(input(a) /\ output(a));
    internal(a) <=> ~external(a);
    input(a) => enabled(s, a);
