Stack(E): trait
  % Common LIFO operators.
  includes StackBasics, 
           Count(E, Stack, empty, push, count),
           Size(E, Stack, empty, push, size),
           MemberOps(E, Stack, push for insert)
  introduces isEmpty: Stack[E] -> Bool
  asserts with s: Stack[E]
    isEmpty(s) <=> s = empty
  implies with s: Stack[E]
    traits Container(E, Stack, empty, push, top for head, pop for tail);
    sort Stack[E] partitioned by top, pop, isEmpty;
    converts top, pop, count, \in, size, isEmpty
      exempting top(empty), pop(empty)
